// Written by Dr. YIP Chi Lap [Beta]
//   for Ultraviolet Radiation Measurement and Application Design Competition



// Thresholds are from data sheet of UV module
const float thresholds[] = {
  0.050, 0.227, 0.318, 0.408, 0.503,
  0.606, 0.696, 0.795, 0.881, 0.976,
  1.079
};



void setup() {
  Serial.begin(9600);
  pinMode(A0,INPUT);
  pinMode(2,OUTPUT);
  analogReference(DEFAULT);  // 5V
}



void loop() {
  // 5V reference, so multiply by 5.0 below.
  float sensorVoltage = analogRead(A0)*5.0/1024;
  int uvIndex;
  for (uvIndex=0; uvIndex<12; ++uvIndex) {
    if (sensorVoltage <= thresholds[uvIndex]) break;
  }
  Serial.print(uvIndex);
  Serial.print(" ");
  Serial.println(sensorVoltage);
  delay(1000);          // Sample every second
  if (uvIndex>=1) {
    digitalWrite(2,LOW);
  } else {
    digitalWrite(2,HIGH);
  }
}
